#include <stdio.h>
#include <stdlib.h>

typedef enum { analisi, disegno, informatica, fisica} Corso;

typedef struct {
        int giorno;
        int mese;
        int anno; } Data;

typedef struct { char codice[8];
                 Data data;
                 Corso corso;
                 int voto; } Esame;

typedef struct { Esame esami[1000];
                 int n; } Esami;

int Bisest(int a);
int IsCorrect(int gg,int mm,int aa);                 
void Inizializza(Esami *es);
void aggiungiEsame(Esami *es);
void leggiEsame(Esame *es);
void stampaEsame(Esame es);
float media(Esami es, int corso);
void mediaView(Esami es);
void menu();
void mediaAlunnoView(Esami es);
void stampaView(Esami es);

int main(int argc, char *argv[])
{
  Esami esami;
  int scelta;
  Inizializza(&esami);
  do { 
       menu();
       do {
           scanf("%d",&scelta); }
       while((scelta<1)||(scelta>5));
       switch(scelta) {
                 case 1: {
                      aggiungiEsame(&esami);
                      break; }
                 case 2: {
                      stampaView(esami);
                      break; }
                 case 3: {
                      mediaView(esami);
                      break; }
                 case 4: {
                      mediaAlunnoView(esami);
                      break; }
                }
                }
  while(scelta!=5);
  system("PAUSE");	
  return 0;
}

void Inizializza(Esami *es) {
     es->n=0;
}

void mediaAlunnoView(Esami es) {}

void menu() {
     printf("Introduci 1 per aggiungere un esame\n");
     printf("Introduci 2 per visualizzare un esame\n");
     printf("Introduci 3 per visualizzare la media dei voti di un dato corso\n");
     printf("Introduci 4 per visualizzare la media dei voti di un dato studente\n");
     printf("Introduci 5 per visualizzare uscire\n");
}

void aggiungiEsame(Esami *es) {
     leggiEsame(&(es->esami[es->n]));
     es->n++;
}

void leggiEsame(Esame *es) {
     int i,gg,mm,aa;
     printf("Introduci il codice dello studente\n");
     scanf("%s",es->codice);
     printf("Introduci 0 per analisi, 1 per disegno, 2 per informatica 0 3 per fisica\n");
     do {
         scanf("%d",&i); }
     while((i<0)||(i>3));
     es->corso=i;
     printf("Introduci la data dell'esame come gg-mm-aaaa\n");
     do {
     scanf("%d %d %d",&gg,&mm,&aa); }
     while(IsCorrect(gg,mm,aa)==0); 
     es->data.giorno=gg;
     es->data.mese=mm;
     es->data.anno=aa;
     printf("Introduci il voto in trentesimi\n");
     do {
         scanf("%d",&i); }
     while((i<0)||(i>30));
     es->voto=i;     
}

void stampaEsame(Esame es) {
     printf("\nCodice studente: %s\n",es.codice);
     printf("Corso: ");
     switch(es.corso) {
                      case 0: { printf("analisi\n");
                                break; }
                      case 1: { printf("disegno\n");
                                break; }
                      case 2: { printf("informatica\n");
                                break; }
                      case 3: { printf("fisica\n");
                                break; }
                      }
     printf("Data: %d-%d-%d\n",es.data.giorno,es.data.mese,es.data.anno);
     printf("Voto: %d\n",es.voto);
}

float media(Esami es, int corso) {
      int i;
      int somma=0;
      int j=0;
      float media;
      for(i=0;i<es.n;i++) {
                          if(es.esami[i].corso==corso) {
                                              somma+=es.esami[i].voto;
                                              j++;
                          }
      }
      if(j==0) 
               return -1;
      else
          return (((float)somma)/j);     
}

void stampaView(Esami es) {
     int n;
     printf("Introduci il numero di esame da stampare\n");
     do {
         scanf("%d",&n); }
     while((n<0)||(n>es.n));
     stampaEsame(es.esami[n-1]);    
}

void mediaView(Esami es) {
     int corso;
     float med;
     printf("Introduci 0 per analisi, 1 per disegno, 2 per informatica 0 3 per fisica\n");
     do {
         scanf("%d",&corso); }
     while((corso<0)||(corso>3));
     med=media(es,corso);
     if(med==-1) 
                 printf("Non sono stati eseguiti esami nel corso %d\n",corso);
     else
         printf("La media del corso %d : %f\n",corso,med);     
}

int Bisest(int a) {
  if((((a%4)==0)&&((a%100)!=0))||((a%400)==0))
    return 29;
  else
    return 28;
}

int IsCorrect(int gg,int mm,int aa) {
  int bis;
  bis=Bisest(aa);
  if(aa>=0){
    if((1<=mm)&&(12>=mm)){
      if((1<=gg)&&(31>=gg)){
        if((mm=1)||(mm==3)||(mm==5)||(mm==7)||(mm==8)||(mm==10)||(mm==12)){
          return 1;}
        else
        if((gg<=30)&&((mm==4)||(mm==6)||(mm==9)||(mm==11))){
          return 1;}
        else
        if(gg<=bis){
          return 1;}
        else{
          return 0;}}
      else{
        return 0;}}
    else{
      return 0;}}
  else{
    return 0;}}

